local fr = CreateFrame("Frame")
local name, addon = ...
local loginin = true

local dungeonsName = {}
local amountDungeons = 12
local version = "BFA"
local localPlayer = UnitName("Player")
C_ChatInfo.RegisterAddonMessagePrefix("Praetorians")

dungeonsName[1] = "ATAL' DAZAR"
dungeonsName[1754] = "Freehold"
dungeonsName[2] = "KING REST"
dungeonsName[3] = "OPERATION MECHAGON"
dungeonsName[1864] = "SHRINE OF STORM"
dungeonsName[1822] = "SIEGE OF BORULAS"
dungeonsName[1877] = "TEMPEL OF SETHRALISS"
dungeonsName[1594] = "THE MOTHERLORDE"
dungeonsName[1841] = "THE UNDERROT"
dungeonsName[1771] = "TOL DAGOR"
dungeonsName[1862] = "WAYCREST MANOR"


--Credits: Eranuren/Elaiah, Sorfarion, Vixxyn

-- GUI!
local frame = CreateFrame("Frame", "Praetorians_Keys", UIParent, "BasicFrameTemplateWithInset")
frame:ClearAllPoints()
frame:SetWidth(400)
frame:SetHeight(300)
frame:SetMovable(true)
frame:EnableMouse(true)
frame:SetUserPlaced(true)
frame:SetScript("OnMouseDown", frame.StartMoving)
frame:SetScript("OnMouseUp", function (self)
    frame:StopMovingOrSizing()
    Praetorians.XPos = self:GetLeft()
    Praetorians.YPos = self:GetBottom()
end)

local title = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
title:SetPoint("LEFT", frame.TitleBg, "LEFT", 5, 0)


local Name = CreateFrame( "EditBox", nil, frame , "InputBoxTemplate")
local text  = frame:CreateFontString(nil, "ARTWORK")
text:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
text:SetPoint("TOPLEFT", 10, -80)
text:SetJustifyH("LEFT")

local function globalScore(name) 
    local dung = {}
    if Praetorians[version][name] then
        for i, table in pairs(Praetorians[version][name]["Dungeons"]) do
            for key, result in pairs(table) do
                if not dung[i] then
                    dung[i] = result["Score"]
                elseif result["Score"] > dung[i] then
                    dung[i] = result["Score"]
                end
            end
        end
        local score = 0
        local size = 0
        for i, v in pairs(dung) do
            score = score + v
            size = size + 1
        end
        return score, size
    end
end

local dungeon = "ATAL' DAZAR"
local dungeonid = 1
local dropDown = CreateFrame("FRAME", "WPDemoDropDown", frame, "UIDropDownMenuTemplate")
dropDown:SetPoint("TOPLEFT", 230, -35)
UIDropDownMenu_SetWidth(dropDown, 120)
UIDropDownMenu_SetText(dropDown, "Dungeon: "..dungeon)
UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    if (level or 1) == 1 then
        if not Praetorians then return end
        for i, v in pairs(dungeonsName) do
            info.text, info.checked = v, dungeon == v
            info.menuList, info.hasArrow = i, true
            UIDropDownMenu_AddButton(info, level)
        end
    else
        if not Praetorians[version][Name:GetText()]["Dungeons"][menuList] then return end
        for i, v in pairs (Praetorians[version][Name:GetText()]["Dungeons"][menuList]) do
            info.text, info.arg1, info.checked = i, i, false
            info.func = function(self) 
                dungeon = dungeonsName[menuList]
                dungeonid = menuList
                UIDropDownMenu_SetText(dropDown, "Dungeon: "..dungeon)
                local timed = "No"
                if Praetorians[version][Name:GetText()]["Dungeons"][menuList][i]["OnTime"] then
                    timed = "Yes"
                end
                local score, size = globalScore("Freddocinoo")
                text:SetText("Role: "..Praetorians[version][Name:GetText()]["Role"].."\nGlobal Score:"..score/size.."\nDungeons done: "..size.."/"..amountDungeons.."\nKey level: "..i.."\nonTime: "..timed.."\nScore: "..Praetorians[version][Name:GetText()]["Dungeons"][menuList][i]["Score"].."\nDPS: "..Praetorians[version][Name:GetText()]["Dungeons"][menuList][i]["Damage"])
                CloseDropDownMenus()
            end
            
            UIDropDownMenu_AddButton(info, level)
        end
    end
end)
dropDown:Hide()

local btn = {}
for i = 1, 10 do
    btn[i] = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
    btn[i]:SetPoint("Right", frame, "TOP", 35, -50-(i*22))
    btn[i]:SetSize(220, 20)
    --btn[i]:SetText(i)
    btn[i]:RegisterForClicks("AnyUp")
    btn[i]:SetScript("OnMouseDown", function(self)
        Name:SetText(btn[i]:GetText())
        dropDown:Show()
        for i = 1, 10 do
            btn[i]:Hide()
        end
    end)
    btn[i]:Hide()
end

Name:SetPoint("TOPLEFT", 20, -40)
Name:SetWidth(220)
Name:SetHeight(20)
Name:SetMovable(false)
Name:Insert("Enter Name")
Name:SetScript("OnTextChanged", function(self)
    text:SetText("")
    dropDown:Hide()
    for i = 1, 10 do
        btn[i]:Hide()
        btn[i]:SetText("")
    end
    local search = self:GetText()
    local found = search_player(Praetorians[version], search)
    if #found ~= 0 then
        if #found >= 10 then
            return text:SetText("Too much data founded.\nPlease enter more name.")
        end
        for i, v in pairs(found) do
            btn[i]:SetText(v)
            btn[i]:Show()  
        end
    else
        return text:SetText("I couldn't found this Name.\nBe care full about 'CAPS'.")
    end
end)
Name:SetScript("OnEscapePressed", function() frame:Hide() end)

frame:Hide()

function search_player(array, pattern) 
    local players = {}
    for i, v in pairs(array) do
        if string.find(i, pattern) then
            table.insert(players, i)
        end
    end
    return players
end

local function scoring(dmg, key, intime) 
    local points = 0
    if dmg >= 15000 and dmg < 20000 then
        points = points + 25
    elseif dmg >= 20000 and dmg < 25000 then
        points = points + 50
    elseif dmg >= 25000 and dmg < 30000 then
        points = points + 100
    elseif dmg >= 30000 and dmg < 35000 then
        points = points + 150
    elseif dmg >= 35000 and dmg < 40000 then
        points = points + 200
    elseif dmg >= 40000 and dmg < 45000 then
        points = points + 250
    elseif dmg >= 45000 and dmg < 50000 then
        points = points + 300
    elseif dmg >= 50000 and dmg < 55000 then
        points = points + 350
    elseif dmg >= 55000 and dmg < 60000 then
        points = points + 400
    elseif dmg >= 60000 then
        points = points + 450
    end
    if intime then
        if key >= 2 and key <= 15 then
            points = points + (key*10)
        elseif key == 16 then
            points = points + 200
        elseif key == 17 then
            points = points + 250
        elseif key == 18 then
            points = points + 300
        elseif key == 19 then
            points = points + 350
        elseif key == 20 then
            points = points + 400
        end
    end
    return points
end

function sendData()
    if Praetorians[version] then
        for ply, table1 in pairs(Praetorians[version]) do
            for i, table in pairs(table1["Dungeons"]) do
                for key, result in pairs(table) do
                    C_ChatInfo.SendAddonMessage("Praetorians", localPlayer.."|"..ply.."|"..table1["Role"].."|"..i.."|"..key.."|"..result["Damage"].."|"..(result["OnTime"] and 'true' or 'false').."|"..result["Score"], "GUILD")
                end
            end
        end
    end
end

fr:RegisterEvent("ADDON_LOADED")
fr:RegisterEvent("CHAT_MSG_ADDON")
fr:RegisterEvent("PLAYER_LOGIN")
fr:RegisterEvent("CHALLENGE_MODE_COMPLETED")
fr:SetScript("OnEvent",function(self,event,...)
    if (loginin == true and ((event == "ADDON_LOADED" and name == arg1) or (event == "PLAYER_LOGIN"))) then
        print("Keys were loaded!")
        loginin = nil
        if not Praetorians then Praetorians = { } end
        if not Praetorians[version] then Praetorians[version] = {} end
        if not Praetorians.XPos then Praetorians.XPos = 0 end
        if not Praetorians.YPos then Praetorians.YPos = 0 end
        frame:ClearAllPoints()
        frame:SetPoint("BOTTOMLEFT", Praetorians.XPos, Praetorians.YPos)
        fr:UnregisterEvent("ADDON_LOADED")
        fr:UnregisterEvent("PLAYER_LOGIN")
        sendData()
    elseif event == "CHAT_MSG_ADDON" then
        local prefix, msg = ...
        if (prefix == "Praetorians") then
            local lp, Player, Role, DungeonID, KeyLevel, Damage, OnTime, Score = string.split("|", msg)
            DungeonID = tonumber(DungeonID)
            KeyLevel = tonumber(KeyLevel)
            Damage = tonumber(Damage)
            Score = tonumber(Score)

            if lp == localPlayer then return end

            if not Praetorians[version][Player] then
                Praetorians[version][Player] = {}
                Praetorians[version][Player]["Role"] = Role
                Praetorians[version][Player]["Dungeons"] = {}
                Praetorians[version][Player]["Dungeons"][DungeonID] = {}
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel] = {}
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Damage"] = Damage
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["OnTime"] = OnTime
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Score"] = Score
            elseif not Praetorians[version][Player]["Dungeons"][DungeonID] then
                Praetorians[version][Player]["Dungeons"][DungeonID] = {}
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel] = {}
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Damage"] = Damage
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["OnTime"] = OnTime
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Score"] = Score
            elseif not Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel] then
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel] = {}
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Damage"] = Damage
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["OnTime"] = OnTime
                Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Score"] = Score
            else 
                if Damage > Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Damage"] then
                    Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Damage"] = Damage
                    Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["OnTime"] = OnTime
                    Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Score"] = Score
                elseif Score > Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Score"] then
                    Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Damage"] = Damage
                    Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["OnTime"] = OnTime
                    Praetorians[version][Player]["Dungeons"][DungeonID][KeyLevel]["Score"] = Score
                end
            end
        end
    elseif event == "CHALLENGE_MODE_COMPLETED" then
        local PartyMembers = {}
        for group = 1, GetNumGroupMembers()-1 do
            local name = GetUnitName("Party"..group, true)
            PartyMembers[name] = true
        end
        PartyMembers[UnitName("player")] = true
        local currentCombat = Details:GetCurrentCombat()
        local combatTime = currentCombat:GetCombatTime()
        local combat = Details:GetCombat (-1)
        for _, actor in combat:GetContainer(DETAILS_ATTRIBUTE_DAMAGE):ListActors() do
            if (actor:IsPlayer()) then
                if not PartyMembers[actor:name()] then return print("Ugh?! A Player joined before M+ were done?!") end
                local role = UnitGroupRolesAssigned(actor:name());
                --if role == "HEALER" then return end
                if not Praetorians[version][actor:name()] then 
                    Praetorians[version][actor:name()] = {}
                    Praetorians[version][actor:name()]["Role"] = role
                    Praetorians[version][actor:name()]["Dungeons"] = {}
                end
                if not Praetorians[version][actor:name()]["Score"] then
                    Praetorians[version][actor:name()]["Score"] = 0
                end
                local mapChallengeID, KeyLevel, time, onTime = C_ChallengeMode.GetCompletionInfo()
                if not Praetorians[version][actor:name()]["Dungeons"][mapChallengeID] then 
                    Praetorians[version][actor:name()]["Dungeons"][mapChallengeID] = {}
                end
                if not Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel] then
                    Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel] = {}
                    local dmg = actor.total/combat:GetCombatTime()
                    Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["Damage"] = dmg
                    Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["OnTime"] = onTime
                    local score = scoring(dmg, KeyLevel, onTime)
                    Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["Score"] = score
                    --Praetorians[version][actor:name()]["Score"] = Praetorians[version][actor:name()]["Score"] + score
                else
                    local dmg = actor.total/combat:GetCombatTime()
                    local olddmg = Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["Damage"]
                    if dmg > olddmg then
                        if actor:name() == localPlayer then
                            print("Congratz, you improve yours Damage from last time!")
                            print("Last time: "..Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["Damage"])
                            print("Now: "..dmg)
                        end
                        Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["Damage"] = dmg
                        Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["OnTime"] = onTime
                        local score = scoring(dmg, KeyLevel, onTime)
                        Praetorians[version][actor:name()]["Dungeons"][mapChallengeID][KeyLevel]["Score"] = score
                        --Praetorians[version][actor:name()]["Score"] = Praetorians[version][actor:name()]["Score"] + score
                    end

                end
            end
        end
        print("Updated the Data!")
        sendData()
    end
end)



SLASH_KEYS1 = "/keys"
SlashCmdList["KEYS"] = function(msg)
    local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
    if cmd == "show" then
        local count = 0
        for _ in pairs(Praetorians[version]) do count = count + 1 end
        title:SetText("Praetorians Keys - ".. count .." Users founded.")
        frame:Show()
    elseif cmd == "Reset" then
        Praetorians = { } 
        Praetorians[version] = { } 
    elseif not cmd then
        local count = 0
        for _ in pairs(Praetorians[version]) do count = count + 1 end
        title:SetText("Praetorians Keys - ".. count .." Users founded.")
        frame:Show()
    end
end